

#include "predef.h"
#include <basictypes.h>
#include <constants.h>
#include <ip.h>
#include <stdio.h>
#include <ctype.h>
#include <ucos.h>
#include <utils.h>
#include <string.h>
#include <ppp.h>

#ifndef GM862_GPRS_H_
#define GM862_GPRS_H_

#define PRIORITY				(MAIN_PRIO-2)
#define SERIALPORT_TO_USE 		(1) //0 for the main port, 1 for the 10pin aux serial port
static char ACCOUNT_NAME[80] = "guest";
static char ACCOUNT_PASS[80] = "guest";
static char DIAL_STRING[80] = "ATD*99***1#";

class GM862_GPRS {
private:
	int priority;
	bool allDone;
	pppoptions pppo;
	bool GPRSLink;
	DWORD GPRSTaskStack[USER_TASK_STK_SIZE/2];

	void connectionLoop();
	static void staticconnectionLoop(void *);
	void ShowErrors(const char *msg, int errv);
	void DisplayCellErrorCode(int code);

public:

	int failCount;
	GM862_GPRS();
	void start();
	void disconnect();
	void connect();
	bool getActiveConnection();
};

static char CellErrorCode[][80] = { "phone failure", "0",
		"No connection to phone", "1", "phone-adaptor link reserved", "2",
		"operation not allowed", "3", "operation not supported", "4",
		"PH-SIM PIN required", "5", "SIM not inserted", "10",
		"SIM PIN required", "11", "SIM PUK required", "12", "SIM failure",
		"13", "SIM busy", "14", "SIM wrong", "15", "incorrect password", "16",
		"SIM PIN2 required", "17", "SIM PUK2 required", "18", "memory full",
		"20", "invalid index", "21", "not found", "22", "memory failure", "23",
		"text string too long", "24", "invalid characters in text string",
		"25", "dial string too long", "26",
		"invalid characters in dial string", "27", "no network service", "30",
		"network timeout", "31", "network not allowed - emergency calls only",
		"32", "network personalization PIN required", "40",
		"network personalization PUK required", "41",
		"network subset personalization PIN required", "42",
		"network subset personalization PUK required", "43",
		"service provider personalization PIN required", "44",
		"service provider personalization PUK required", "45",
		"corporate personalization PIN required", "46",
		"corporate personalization PUK required", "47", "Camera not found",
		"50", "Camera Initialization Error", "51", "Camera not Supported",
		"52", "No Photo Taken", "53", "NET BUSY...Camera TimeOut", "54",
		"Camera Error", "55", "unknown ", "100", "Illegal MS (#3)* ", "103",
		"Illegal ME (#6)* ", "106", "GPRS service not allowed (#7)* ", "107",
		"PLMN not allowed (#11)* ", "111", "Location area not allowed (#12)* ",
		"112", "Roaming not allowed in this location area (#13)* ", "113",
		"service option not supported (#32)* ", "132",
		"requested service option not subscribed (#33)* ", "133",
		"service option temporarily out of order (#34)* ", "134",
		"unspecified GPRS error ", "148", "PDP authentication failure ", "149",
		"invalid mobile class ", "150", "Network survey error (No Carrier)* ",
		"257", "Network survey error (Busy)* ", "258",
		"Network survey error (Wrong request)* ", "259",
		"Network survey error (Aborted)* ", "260",
		"generic undocumented error ", "400", "wrong state ", "401",
		"wrong mode ", "402", "context already activated ", "403",
		"stack already active ", "404", "activation failed ", "405",
		"context not opened ", "406", "cannot setup socket ", "407",
		"cannot resolve DN ", "408", "timeout in opening socket ", "409",
		"cannot open socket ", "410", "remote disconnected or timeout ", "411",
		"connection failed ", "412", "tx error ", "413", "already listening ",
		"414", "ok ", "420", "connect ", "421", "disconnect ", "422", "error ",
		"423", "wrong state ", "424", "can not activate ", "425",
		"can not resolve name ", "426", "can not allocate control socket ",
		"427", "can not connect control socket ", "428",
		"bad or no response from server ", "429", "not connected ", "430",
		"already connected ", "431", "context down ", "432",
		"no photo available ", "433", "can not send photo ", "434",
		"generic undocumented error ", "550", "wrong state ", "551",
		"wrong mode ", "552", "context already activated ", "553",
		"stack already active ", "554", "activation failed ", "555",
		"context not opened ", "556", "cannot setup socket ", "557",
		"cannot resolve DN ", "558", "timeout in opening socket ", "559",
		"cannot open socket ", "560", "remote disconnected or timeout ", "561",
		"connection failed ", "562", "tx error ", "563", "already listening ",
		"564", "Camera not found ", "580", "Camera Initialization Error ",
		"581", "Camera not Supported ", "582", "No Photo Taken ", "583",
		"NET BUSY...Camera TimeOut ", "584", "Camera Error ", "585",
		"generic undocumented error ", "600", "wrong state ", "601",
		"can not activate ", "602", "can not resolve name ", "603",
		"can not allocate control socket ", "604",
		"can not connect control socket ", "605",
		"bad or no response from server ", "606", "not connected ", "607",
		"already connected ", "608", "context down ", "609",
		"no photo available ", "610", "can not send photo ", "611",
		"resource used by other instance ", "612",
		"Network survey error (No Carrier)* ", "657",
		"Network survey error (Busy)* ", "658",
		"Network survey error (Wrong request)* ", "659",
		"Network survey error (Aborted)* ", "660", "Unspecified ", "731",
		"Activation command is busy ", "732",
		"Activation started with CMUX off ", "733",
		"Activation started on invalid CMUX ", "734",
		"Remote SIM already active ", "736", "Invalid parameter ", "737" };
#endif /* GM862_GPRS_H_ */
