#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <NetworkDebug.h>
#include <mailto.h>
#include <dns.h>
#include <netinterface.h>
#include <qspi.h>


#include "GM862_GPRS.h"

extern "C" {
void UserMain(void * pd);
}

const char * AppName = "GPRSLink_Test";

GM862_GPRS gprs;

void UserMain(void * pd) {
	InitializeStack();
	if (EthernetIP == 0)
		GetDHCPAddress();
	OSChangePrio(MAIN_PRIO);
	EnableAutoUpdate();
	StartHTTP();

#ifdef _DEBUG
	InitializeNetworkGDB_and_Wait();
#endif



	OS_SEM QSPI_SEM;
	OSSemInit(&QSPI_SEM, 0);


	char buff[1000];
	int pBuff = 0;
	int mailSent = 0;
	int time = 0;
	PCSTR data;

	QSPIInit(1000000, 11, 0xE, 1, 0, 1, TRUE,0x30, 0x30);

	iprintf("Application started\n");
	gprs.start();
	gprs.connect();
	while (1) {
		mailSent = 0;
		time = 0;
		while (time<60) {
			short RawTempData = 0;
			QSPIStart(NULL, (BYTE*) &RawTempData, 2, &QSPI_SEM); // Receive data via QSPI
			OSSemPend(&QSPI_SEM, 0); // Wait for QSPI to complete

			pBuff+=sprintf(buff+pBuff,"Temp: %gF\r\n (%d minutes from last email)\r\n",(((RawTempData * 0.25) * 9) / 5) + 32, time);
			OSTimeDly(TICKS_PER_SECOND * 1);
			time++;
		}
		buff[pBuff] = '\0';
		pBuff=0;
		data = buff;
		iprintf("starting\r\n");
		// Opening GPRS connection
		while (mailSent != 1) {
			mailSent = SendMailAsServer("email_address_from",
					"email_address_to",
					"subject", data);
			OSTimeDly(TICKS_PER_SECOND * 5);
		}
	}
}
